local frame = CreateFrame("FRAME","IciclesCounterUI",UIParent); -- Need a frame to respond to events
frame:RegisterEvent("PLAYER_LOGIN"); -- Fired when saved variables are loaded
frame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
frame:RegisterEvent("UNIT_AURA");



frame:SetWidth(128); -- Set these to whatever height/width is needed 
frame:SetHeight(64); -- for your Texture

frame.text = frame:CreateFontString(); 
frame.text:SetPoint("CENTER", 0, 0)
frame.text:SetSize(128, 64)
frame.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")

frame:SetMovable(true);

frame.tex = frame:CreateTexture(nil, "BACKGROUND")
frame.tex:SetAllPoints()
frame.tex:SetColorTexture(1, 1, 1, 0.5)

frame:SetPoint("CENTER",0,0);


function frame:RecalculateUI()
	frame.text:SetFont("Fonts\\FRIZQT__.TTF", IciclesCounter.size, "OUTLINE");
	frame.text:SetHeight(IciclesCounter.size*1.2);
	frame.text:SetWidth(IciclesCounter.size*1.2);
	frame:SetHeight(frame.text:GetHeight());
	frame:SetWidth(frame.text:GetWidth());
	frame.tex:SetAllPoints()

		frame:Hide();

	if IciclesCounter.show then
		frame:Show();
	end

frame:ClearAllPoints()
frame:SetPoint(IciclesCounter.point,IciclesCounter.relativeTo,IciclesCounter.relativePoint,IciclesCounter.xOf,IciclesCounter.yOf);

end


SLASH_ICICLESCOUNTER1 = "/ic"
SLASH_ICICLESCOUNTER2 = "/iciclescounter"
SlashCmdList["ICICLESCOUNTER"] = function(msg)
	local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")	
	if cmd == "move" then

	IciclesCounter.movable = not IciclesCounter.movable;
	if IciclesCounter.movable then
		print("Start moving mouse to adjust positon of the frame.");
		frame:SetMovable(true);
		frame:StartMoving()
	else
		print("Position saved.");
		frame:StopMovingOrSizing()
		frame:SetMovable(false);
		IciclesCounter.point,IciclesCounter.relativeTo,IciclesCounter.relativePoint,IciclesCounter.xOf,IciclesCounter.yOf = frame:GetPoint(1);
		frame:RecalculateUI()
	end
	
	
   elseif cmd == "size" then
	IciclesCounter.size = tonumber(args)
	print("Font size set to " .. IciclesCounter.size);
	frame:RecalculateUI()
	elseif cmd == "show" then
	IciclesCounter.show = true;
	frame:RecalculateUI()
	print("Icicles counter showed")
	elseif cmd == "hide" then
	IciclesCounter.show = false;
	frame:RecalculateUI()
	print("Icicles counter vanished")
	elseif cmd == "reset" then
	frame:Defaults();
	frame:RecalculateUI()
	print("Icicles counter set to default")
   else
   print("Available commands: show, hide, move, size, reset")
   end
   
end 



function frame:Defaults()
	IciclesCounter = {};
	IciclesCounter.size = 60;
	IciclesCounter.movable = false;
	IciclesCounter.point = "CENTER";
	IciclesCounter.xOf = 0;
	IciclesCounter.yOf = 0;
	IciclesCounter.show = true;
	IciclesCounter.relativeTo = UIParent;
	IciclesCounter.relativePoint = "CENTER"
	frame.text:SetFont("Fonts\\FRIZQT__.TTF", IciclesCounter.size, "OUTLINE");
end


function frame:Icicles()
	local name,count,max,_
	max=0;
	for i=1,40 do
		name,_,count=UnitAura("player",i);
		if name == "Icicles" then
			max=count;
		end
		frame.text:SetText(max)
	end
	if max == 5 then 
		frame.tex:SetColorTexture(0, 0.5, 1, 0.7)
	else
		frame.tex:SetColorTexture(0, 0, 0, 0)
	end
	
end

function frame:OnEvent(event, arg1)
--print("gege");
 if event == "PLAYER_LOGIN" then
  --print("hello");
  if IciclesCounter == nil then
	frame:Defaults();
	frame:RecalculateUI()
	
  end
  if IciclesCounter then
  IciclesCounter.movable = false;
  frame.text:SetFont("Fonts\\FRIZQT__.TTF", IciclesCounter.size, "OUTLINE");
   --frame:LoadClockStatus();
   --print(IciclesCounter.point)
   
   frame:RecalculateUI()
  end
 elseif event == "PLAYER_LOGOUT" then
	--print("bz");
   --frame:SaveClockStatus();
 end
 
 if event == "UNIT_AURA" then
	frame:Icicles();
 
 end
 
end


frame:Hide();


frame:SetScript("OnEvent", frame.OnEvent);
